# alphaBeta.py
# Generic function to choose best next move for gnode
#
def chooseMove (NodeClass, gnode, maxDepth=6) :
    "Choose bestMove for gnode along w final value"
    alpha,beta = (gnode.alpha, gnode.beta)
    if gnode.depth < maxDepth and not gnode.over() :
        for move in gnode.moves :
            nxtGnode = NodeClass(gnode.board,gnode.player,gnode.depth+1)
            nxtGnode.move(move)
            nxtGnode.alpha, nxtGnode.beta = (alpha,beta)
            chooseMove(NodeClass, nxtGnode,maxDepth)  # recursion here
            keep = (gnode.next == None)     # 1st of sequence
            if gnode.maximizing() :
                if keep or nxtGnode.value > gnode.value :
                    gnode.value = nxtGnode.value
                    gnode.next  = nxtGnode
                    gnode.bestMove = move
                    alpha = max(alpha, gnode.value)
                    if gnode.value >= beta  : return gnode
            else : 
                if keep or nxtGnode.value < gnode.value :
                    gnode.value = nxtGnode.value
                    gnode.next  = nxtGnode
                    gnode.bestMove = move
                    beta = min(beta, gnode.value)
                    if gnode.value <= alpha : return gnode
    return gnode
