# minimax.py
# Generic function to choose best next move for gnode
#
def chooseMove (NodeClass, gnode, maxDepth=6) :
    "Choose bestMove for gnode along w final value"
    if gnode.depth < maxDepth and not gnode.over() :
        for move in gnode.moves :
            nxtGnode = NodeClass(gnode.board,gnode.player,gnode.depth+1)
            nxtGnode.move(move)
            chooseMove(NodeClass, nxtGnode,maxDepth)  # recursion here
            keep = (gnode.next == None)     # 1st of sequence
            if gnode.maximizing() :
                if keep or nxtGnode.value > gnode.value :
                    gnode.value = nxtGnode.value
                    gnode.next  = nxtGnode
                    gnode.bestMove = move
            else : 
                if keep or nxtGnode.value < gnode.value :
                    gnode.value = nxtGnode.value
                    gnode.next  = nxtGnode
                    gnode.bestMove = move
    return gnode
